use WaspTrackAsset
Go

CREATE PROCEDURE [dbo].[SpDeptCleanUp]
AS
BEGIN

DECLARE @dept_count int,
@dept_id int,
@dept_code varchar(30)

DECLARE department_cursor CURSOR FOR
select [departments].[department_id], [departments].[code] from [dbo].[departments] where [department_id] > 0 and [record_status] = 1

open department_cursor
while 1=1
BEGIN
FETCH department_cursor into @dept_id, @dept_code
if (@@fetch_status<>0)
GOTO out_of_dept

if((select COUNT(*) from departments where code = @dept_code and record_status = 1) > 1)
BEGIN
SET @dept_count = (select COUNT(*) from departments where code = @dept_code and record_status = 1) - 1
UPDATE departments SET code = SUBSTRING(code, 0, (LEN(code) - LEN(CAST(@dept_count as varchar))) + 1) + CAST(@dept_count as varchar) WHERE department_id = @dept_id
END
END
out_of_dept:
close department_cursor

DEALLOCATE department_cursor
END